## net.sf.saxon.expr
Class Expression

    java.lang.Object
      net.sf.saxon.expr.Expression

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

Direct Known Subclasses:
  Assignation, AxisExpression, BinaryExpression, CompareToIntegerConstant, ContextItemExpression, ErrorExpression, FilterExpression, FunctionCall, IfExpression, IndexedFilterExpression, IndexedLookupExpression, Instruction, IntegerRangeTest, IsLastExpression, Literal, NumberInstruction, PathExpression, PatternMatchExpression, PatternSponsor, PositionRange, SimpleContentConstructor, SimpleExpression, SimpleMappingExpression, SingleNodeExpression, SliceExpression, SortExpression, StreamingCopy, SuppliedParameterReference, TailExpression, TupleExpression, TupleSorter, UnaryExpression, VariableReference

    public abstract class Expression

extends Object
implements SequenceIterable, EvaluableItem, Serializable, InstructionInfoProvider, Container

Interface supported by an XPath expression. This includes both compile-time and run-time methods.

See Also:
  Serialized Form

Field Summary
`static int` `EVALUATE_METHOD`
`static int` `ITERATE_METHOD`
`static int` `PROCESS_METHOD`

Constructor Summary
`Expression()`

Method Summary
`void` `adoptChildExpression(Expression child)` Set up a parent-child relationship between this expression and a given child expression.
`void` `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`int` `computeDependencies()` Compute the dependencies of an expression, as the union of the dependencies of its subexpressions.
`int` `computeSpecialProperties()`
`void` `computeStaticProperties()` Compute the static properties.
`abstract void` `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure.
`Expression` `doPromotion(Expression subexpression, PromotionOffer offer)` Promote a subexpression if possible, and if the expression was changed, carry out housekeeping to reset the static properties and correct the parent pointers in the tree
`boolean` `effectiveBooleanValue(XPathContext context)` Get the effective boolean value of the expression.
`String` `evaluateAsString(XPathContext context)` Evaluate an expression as a String.
`Item` `evaluateItem(XPathContext context)` Evaluate an expression as a single item.
`int` `getCardinality()` Determine the static cardinality of the expression.
`int` `getColumnNumber()` Get the column number of the expression
`Procedure` `getContainingProcedure()` Get the Procedure containing this expression.
`int` `getDependencies()` Determine which aspects of the context the expression depends on.
`Executable` `getExecutable()` Get the executable containing this expression
`int` `getHostLanguage()` Get the host language (XSLT, XQuery, XPath) used to implement the code in this container
`int` `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
`InstructionInfo` `getInstructionInfo()` Get InstructionInfo for this expression
`int` `getIntrinsicDependencies()` Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions.
`abstract ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the expression, if possible.
`int` `getLineNumber()` Get the line number of the expression
`int` `getLocationId()` Get the location ID of the expression
`LocationProvider` `getLocationProvider()` Get the LocationProvider allowing location identifiers to be resolved.
`Container` `getParentExpression()` Get the expression that immediately contains this expression.
`String` `getPublicId()` Get the publicId of the module containing the expression (to satisfy the SourceLocator interface)
`int[]` `getSlotsUsed()` Get the local variables (identified by their slot numbers) on which this expression depends.
`int` `getSpecialProperties()` Get the static properties of this expression (other than its type).
`String` `getSystemId()` Get the systemId of the module containing the expression
`boolean` `hasBadParentPointer()` Diagnostic method: search the tree for an expression whose parent expression is incorrectly set
`SequenceIterator` `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
`Iterator` `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`int` `markTailFunctionCalls(int nameCode, int arity)` Mark tail-recursive calls on stylesheet functions.
`Expression` `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`void` `process(XPathContext context)` Process the instruction, without returning any tail calls
`Expression` `promote(PromotionOffer offer)` Offer promotion for this subexpression.
`boolean` `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`void` `resetStaticProperties()` Reset the static properties.
`void` `setLocationId(int id)` Set the location ID on an expression.
`void` `setParentExpression(Container parent)`
`static void` `setParentExpression(Expression child, Container parent)`
`Expression` `simplify(StaticContext env)` Simplify an expression.
`void` `suppressValidation(int validationMode)` Suppress validation on contained element constructors, on the grounds that the parent element is already performing validation.
`Expression` `typeCheck(StaticContext env, ItemType contextItemType)` Perform type checking of an expression and its subexpressions.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### EVALUATE_METHOD

    public static final int EVALUATE_METHOD

See Also:
  Constant Field Values

### ITERATE_METHOD

    public static final int ITERATE_METHOD

See Also:
  Constant Field Values

### PROCESS_METHOD

    public static final int PROCESS_METHOD

See Also:
  Constant Field Values

Constructor Detail

### Expression

    public Expression()

Method Detail

### getImplementationMethod

    public int getImplementationMethod()

  An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided directly. The other methods will always be available indirectly, using an implementation that relies on one of the other methods.

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

  If the implementation returns a value other than "this", then it is required to ensure that the parent pointer and location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Offer promotion for this subexpression. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### getSpecialProperties

    public final int getSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Returns:
    a set of flags indicating static properties of this expression

### getCardinality

    public int getCardinality()

  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### getItemType

    public abstract ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression, if possible. All expression return sequences, in general; this method determines the type of the items within the sequence, assuming that (a) this is known in advance, and (b) it is the same for all items in the sequence.

  This method should always return a result, though it may be the best approximation that is available at the time.

  Parameters:
    `th` -
  Returns:
    a value such as Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known at compile time)

### getDependencies

    public int getDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.

  Returns:
    a set of bit-significant flags identifying the dependencies of the expression

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Get the immediate sub-expressions of this expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.

  Returns:
    an iterator containing the sub-expressions of this expression

### getParentExpression

    public Container getParentExpression()

  Get the expression that immediately contains this expression. This method returns null for an outermost expression; it also return null in the case of literal values. For an XPath expression occurring within an XSLT stylesheet, this method returns the XSLT instruction containing the XPath expression.

  Returns:
    the expression that contains this expression, if known; return null if there is no containing expression or if the containing expression is unknown.

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate an expression as a single item. This always returns either a single Item or null (denoting the empty sequence). No conversion is done. This method should not be used unless the static type of the expression is a subtype of "item" or "item?": that is, it should not be called if the expression may return a sequence. There is no guarantee that this condition will be detected.

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.

  Specified by:
    `iterate` in interface `SequenceIterable`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext context)
                                  throws XPathException

  Get the effective boolean value of the expression. This returns false if the value is the empty sequence, a zero-length string, a number equal to zero, or the boolean false. Otherwise it returns true.

  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the effective boolean value
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateAsString

    public String evaluateAsString(XPathContext context)
                            throws XPathException

  Evaluate an expression as a String. This function must only be called in contexts where it is known that the expression will return a single string (or where an empty sequence is to be treated as a zero-length string). Implementations should not attempt to convert the result to a string, other than converting () to "". This method is used mainly to evaluate expressions produced by compiling an attribute value template.

  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the value of the expression, evaluated in the current context. The expression must return a string or (); if the value of the expression is (), this method returns "".
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression
    `ClassCastException` - if the result type of the expression is not xs:string?

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the instruction, without returning any tail calls

  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### display

    public abstract void display(int level,
                                 PrintStream out,
                                 Configuration config)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination
    `config` -

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Throws:
    `XPathException`

### setParentExpression

    public void setParentExpression(Container parent)

### setParentExpression

    public static void setParentExpression(Expression child,
                                           Container parent)

### adoptChildExpression

    public void adoptChildExpression(Expression child)

  Set up a parent-child relationship between this expression and a given child expression.

  Note: many calls on this method are now redundant, but are kept in place for "belt-and-braces" reasons. The rule is that an implementation of simplify(), typeCheck(), or optimize() that returns a value other than "this" is required to set the location information and parent pointer in the new child expression. However, in the past this was often left to the caller, which did it by calling this method, either unconditionally on return from one of these methods, or after testing that the returned object was not the same as the original.

  Parameters:
    `child` - the child expression

### setLocationId

    public void setLocationId(int id)

  Set the location ID on an expression.

### getLocationId

    public final int getLocationId()

  Get the location ID of the expression

### getLineNumber

    public int getLineNumber()

  Get the line number of the expression

  Specified by:
    `getLineNumber` in interface `SourceLocator`

### getColumnNumber

    public int getColumnNumber()

  Get the column number of the expression

  Specified by:
    `getColumnNumber` in interface `SourceLocator`

### getSystemId

    public String getSystemId()

  Get the systemId of the module containing the expression

  Specified by:
    `getSystemId` in interface `SourceLocator`

### getPublicId

    public final String getPublicId()

  Get the publicId of the module containing the expression (to satisfy the SourceLocator interface)

  Specified by:
    `getPublicId` in interface `SourceLocator`

### getExecutable

    public Executable getExecutable()

  Get the executable containing this expression

  Specified by:
    `getExecutable` in interface `Container`

### getContainingProcedure

    public Procedure getContainingProcedure()

  Get the Procedure containing this expression. Returns null if the expression is not contained in a Procedure.

### getLocationProvider

    public LocationProvider getLocationProvider()

  Get the LocationProvider allowing location identifiers to be resolved.

  Specified by:
    `getLocationProvider` in interface `Container`

### doPromotion

    public final Expression doPromotion(Expression subexpression,
                                        PromotionOffer offer)
                                 throws XPathException

  Promote a subexpression if possible, and if the expression was changed, carry out housekeeping to reset the static properties and correct the parent pointers in the tree

  Throws:
    `XPathException`

### computeStaticProperties

    public final void computeStaticProperties()

  Compute the static properties. This should only be done once for each expression.

### resetStaticProperties

    public final void resetStaticProperties()

  Reset the static properties. This should be done whenever the expression is changed in a way that might affect the properties. It causes the properties to be recomputed next time they are needed.

### computeSpecialProperties

    public int computeSpecialProperties()

### computeDependencies

    public int computeDependencies()

  Compute the dependencies of an expression, as the union of the dependencies of its subexpressions. (This is overridden for path expressions and filter expressions, where the dependencies of a subexpression are not all propogated). This method should be called only once, to compute the dependencies; after that, getDependencies should be used.

  Returns:
    the depencies, as a bit-mask

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions. For example, position() has an intrinsic dependency on the context position, while (position()+1) does not. The default implementation of the method returns 0, indicating "no dependencies".

  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### suppressValidation

    public void suppressValidation(int validationMode)

  Suppress validation on contained element constructors, on the grounds that the parent element is already performing validation. The default implementation does nothing.

### markTailFunctionCalls

    public int markTailFunctionCalls(int nameCode,
                                     int arity)

  Mark tail-recursive calls on stylesheet functions. For most expressions, this does nothing.

  Returns:
    0 if no tail call was found; 1 if a tail call on a different function was found; 2 if a tail recursive call was found and if this call accounts for the whole of the value.

### getSlotsUsed

    public int[] getSlotsUsed()

  Get the local variables (identified by their slot numbers) on which this expression depends. Should only be called if the caller has established that there is a dependency on local variables.

### getInstructionInfo

    public InstructionInfo getInstructionInfo()

  Get InstructionInfo for this expression

  Specified by:
    `getInstructionInfo` in interface `InstructionInfoProvider`

### hasBadParentPointer

    public boolean hasBadParentPointer()

  Diagnostic method: search the tree for an expression whose parent expression is incorrectly set

### getHostLanguage

    public int getHostLanguage()

  Get the host language (XSLT, XQuery, XPath) used to implement the code in this container

  Specified by:
    `getHostLanguage` in interface `Container`
  Returns:
    typically `Configuration.XSLT` or `Configuration.XQUERY`

Copyright (C) Michael H. Kay. All rights reserved.